=== debian/changelog ===
armnn (23.08-5) unstable; urgency=medium

  * Add upstream patch fixing unsafe usage of memcpy. Fixes FTBFS with GCC-14.
    (Closes: #1074820)

 -- Emanuele Rocca <ema@debian.org>  Tue, 08 Apr 2025 11:56:07 +0200

armnn (23.08-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061918

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:37:30 +0000

armnn (23.08-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1010218)
    - Multiarchify python Build-Depends.
    - Drop python3-all as it only builds for the default python.
    - Annotate python3-numpy build dependency with :native.
    - Export cross compilation variables for setup.py
    - Let dpkg's architecture.mk initialize architecture variables.
    - Patch setup.py to avoid importing the cross built _pyarmnn_version.

  [ Emanuele Rocca ]
  * Add debian/salsa-ci.yml with SALSA_CI_DISABLE_BUILD_PACKAGE_ARM64: 0 to
    build on arm64.

 -- Emanuele Rocca <ema@debian.org>  Sat, 13 Jan 2024 12:34:44 +0100

armnn (23.08-3) unstable; urgency=medium

  * Add 0012-Add-profiling-includes.patch to ship missing profile headers.
  * Ship armnnOnnxParser headers.
  * d/rules: enable ProfilingGuidTests.
  * Add new autopkgtest 'sample'.

 -- Emanuele Rocca <ema@debian.org>  Fri, 01 Sep 2023 16:17:24 +0200

armnn (23.08-2) unstable; urgency=medium

  * New changelog stanza to please dgit.
  * Update d/copyright adding all missing sections.

 -- Emanuele Rocca <ema@debian.org>  Thu, 31 Aug 2023 12:43:51 +0200

armnn (23.08-1) unstable; urgency=medium

  * New upstream release. (Closes: #1037579, #1042942)
  * Port all Debian patches to latest upstream.
  * Rename binary packages for SONAME bumps:
    - libarmnn22 -> libarmnn33
    - libarmnntfliteparser22 -> libarmnntfliteparser24
    - libarmnn-cpuacc-backend22 -> libarmnn-cpuacc-backend33
    - libarmnnaclcommon22 -> libarmnnaclcommon33
    - libarmnn-cpuref-backend22 -> libarmnn-cpuref-backend33
    - libarmnn-gpuacc-backend22 -> libarmnn-gpuacc-backend33
  * New packages to install the right combination of binaries depending on
    usage scenario:
    - armnn-latest-cpu
    - armnn-latest-gpu
    - armnn-latest-cpu-gpu
    - armnn-latest-cpu-gpu-ref
    - armnn-latest-ref
    - armnn-latest-all
  * Drop the following patches applied upstream:
    - use-cmake_thread_libs_init-instead-of-pt
    - remove-cmake-hard-dependencies-on-parser
    - set-error-tests-by-name.patch
    - fix-gcc11-ftbfs.patch
    - fix-gcc12-ftbfs.patch
  * Drop d/patches/disable-unittests-that-can-cause-intermi, use
    --test-case-exclude in d/rules instead.
  * Improve Description field for all binaries.

 -- Emanuele Rocca <ema@debian.org>  Thu, 31 Aug 2023 12:10:39 +0200

armnn (20.08-13) unstable; urgency=medium

  * Fix FTBFS with gcc13 by adding d/patches/fix-gcc13-ftbfs.patch. Thank you
    François Mazen (Closes: #1037579)

 -- Emanuele Rocca <ema@debian.org>  Tue, 01 Aug 2023 21:39:26 +0200

armnn (20.08-12) unstable; urgency=medium

  * Stop building libarmnn-cpuacc-backend22 on armhf. The package requires
    Neon support in order to be built, and there is no guarantee that all
    armhf CPUs have it. Importantly, the armhf buildd conova does not support
    Neon.

 -- Emanuele Rocca <ema@debian.org>  Thu, 02 Feb 2023 16:02:27 +0100

armnn (20.08-11) unstable; urgency=high

  * Urgency high due to 2 RC bugfixes.
  * Remove -DARMCOMPUTENEON=1 from the build options on armhf. Not all armhf
    systems have NEON support (Closes: #998043)
  * Add fix-gcc12-ftbfs.patch to fix building with gcc 12 (Closes: #1030216)
  * python3-pyarmnn: recommend libarmnn-cpuref-backend22 (Closes: #1010217)
  * Fix the lintian warning for "superfluous-file-pattern
    third-party/tensorflow/schema.fbs" by dropping the entry from
    debian/copyright. There is no such file.
  * Set Standards-Version to 4.6.2.
  * Add myself to uploaders with Wookey's permission.

 -- Emanuele Rocca <ema@debian.org>  Wed, 01 Feb 2023 10:21:27 +0100
