=== debian/control ===
Source: armnn
Section: devel
Priority: optional
Maintainer: Francis Murtagh <francis.murtagh@arm.com>
Uploaders: Wookey <wookey@debian.org>, Emanuele Rocca <ema@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), libboost-test-dev (>= 1.64),
  libboost-system-dev (>= 1.64), libboost-filesystem-dev (>= 1.64), 
  libboost-log-dev (>= 1.64), libboost-program-options-dev (>= 1.64), 
  cmake, debhelper-compat (= 12), valgrind, libflatbuffers-dev, 
  libarm-compute-dev [amd64 arm64 armhf],
  swig (>= 4.0.1-5), dh-python, python3-setuptools,
  libpython3-dev, python3-dev:any, python3-numpy:native, xxd,
  flatbuffers-compiler, chrpath
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/deeplearning-team/armnn.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/armnn

Package: libarmnn33t64
Provides: ${t64:Provides}
Replaces: libarmnn33
Breaks: libarmnn33 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libarmnntfliteparser24t64 (= ${binary:Version}),
          python3-pyarmnn (= ${binary:Version})
Description: Inference engine for CPUs, GPUs and NPUs - shared library
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the shared library package.

Package: libarmnn-dev
Architecture: any
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Inference engine for CPUs, GPUs and NPUs - header files
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the development package containing header files.

Package: libarmnntfliteparser24t64
Provides: ${t64:Provides}
Replaces: libarmnntfliteparser24
Breaks: libarmnntfliteparser24 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Arm NN TensorFlow Lite parser library
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the shared library package.


Package: libarmnntfliteparser-dev
Architecture: any
Multi-Arch: same
Depends: libarmnn-dev (= ${binary:Version}),
         libarmnntfliteparser24t64 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Arm NN TensorFlow Lite parser library - header files
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the development package containing header files.

Package: python3-pyarmnn
Architecture: any
Depends: libarmnn33t64 (= ${binary:Version}),
         libarmnntfliteparser24t64 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Recommends: libarmnn-cpuref-backend33
Description: PyArmNN is a python extension for the Armnn SDK
 PyArmNN provides interface similar to Arm NN C++ Api.
 .
 PyArmNN is built around public headers from the armnn/include folder
 of Arm NN. PyArmNN does not implement any computation kernels itself,
 all operations are delegated to the Arm NN library.

Package: libarmnn-cpuacc-backend33
Architecture: arm64
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Arm NN dynamically loadable Neon backend
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the dynamically loadable Neon backend package.

Package: libarmnnaclcommon33t64
Provides: ${t64:Provides}
Replaces: libarmnnaclcommon33
Breaks: libarmnnaclcommon33 (<< ${source:Version})
Architecture: armhf arm64
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Arm NN shared library for Arm Compute Library backends
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the common shared library used by Arm Compute Library backends.

Package: libarmnn-cpuref-backend33
Architecture: any
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}),
         libarmnnaclcommon33t64 (= ${binary:Version}) [arm64 armhf],
         ${shlibs:Depends},
         ${misc:Depends}
Description: Arm NN dynamically loadable Reference backend
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the dynamically loadable Reference backend package.

Package: libarmnn-gpuacc-backend33
Architecture: armhf arm64
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}),
         libarmnnaclcommon33t64 (= ${binary:Version}) [arm64 armhf],
         ${shlibs:Depends},
         ${misc:Depends}
Description: Arm NN dynamically loadable CL backend
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This release supports Caffe, TensorFlow, TensorFlow Lite, and ONNX.
 Arm NN takes networks from these frameworks, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is the dynamically loadable CL backend package.

Package: armnn-latest-cpu
Architecture: arm64
Multi-Arch: same
Depends: libarmnn33t64(= ${binary:Version}),
         libarmnn-cpuacc-backend33 (= ${binary:Version}),
         libarmnntfliteparser24t64 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Arm NN Core and CPU backend
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This packaging release supports TensorFlow Lite.
 Arm NN takes networks from the framework, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
 This is a dependency package containing the latest ArmNN Core package as
 well as the latest CPU backend and the TensorFlow Lite Parser.

Package: armnn-latest-gpu
Architecture: armhf arm64
Multi-Arch: same
Depends: libarmnn33t64 (= ${binary:Version}),
         libarmnn-gpuacc-backend33 (= ${binary:Version}),
         libarmnntfliteparser24t64 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Arm NN Core and GPU backend
 Arm NN is a set of tools that enables machine learning workloads on
 any hardware. It provides a bridge between existing neural network
 frameworks and whatever hardware is available and supported. On arm
 architectures (arm64 and armhf) it utilizes the Arm Compute Library
 to target Cortex-A CPUs, Mali GPUs and Ethos NPUs as efficiently as
 possible. On other architectures/hardware it falls back to unoptimised
 functions.
 .
 This packaging release supports TensorFlow Lite.
 Arm NN takes networks from the framework, translates them
 to the internal Arm NN format and then through the Arm Compute Library,
 deploys them efficiently on Cortex-A CPUs, and, if present, Mali GPUs.
 .
