=== debian/tests/control ===
Tests: build, sample
Depends: g++, armnn-latest-ref, libarmnn-dev
